/**
 * vec - a tiny SIMD vector library in C99
 * 
 * Copyright (c) 2024 Paper
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
**/

#ifndef VEC_IMPL_X86_AVX512F_H_
#define VEC_IMPL_X86_AVX512F_H_

#include "vec/vec.h"

extern const vint8x64_impl   vint8x64_impl_avx512f;
extern const vint16x32_impl  vint16x32_impl_avx512f;
extern const vint32x16_impl  vint32x16_impl_avx512f;
extern const vint64x8_impl   vint64x8_impl_avx512f;
extern const vuint8x64_impl  vuint8x64_impl_avx512f;
extern const vuint16x32_impl vuint16x32_impl_avx512f;
extern const vuint32x16_impl vuint32x16_impl_avx512f;
extern const vuint64x8_impl  vuint64x8_impl_avx512f;

#endif /* VEC_IMPL_X86_AVX512F_H_ */
